CREATE TABLE Site (
  Name VARCHAR(100) PRIMARY KEY,
  SysAdminContact VARCHAR(100),
  UserSupportContact VARCHAR(100),
  SiteSecurityContact VARCHAR(100),
  Latitude REAL,
  Longitude REAL);

CREATE TABLE Service (
  Name VARCHAR(50) PRIMARY KEY,
  Endpoint VARCHAR(255),
  Type VARCHAR(50),
  MajorVersion INT,
  MinorVersion INT,
  PatchVersion INT,
  Site_Name VARCHAR(100) REFERENCES Site(Name),
  WSDL VARCHAR(255),
  Semantics VARCHAR(255));

CREATE TABLE ServiceStatus (
  Service_Name VARCHAR(50) PRIMARY KEY REFERENCES Service(Name),
  Message VARCHAR(255),
  Status INT);

CREATE TABLE ServiceData (
  Service_Name VARCHAR(50) NOT NULL REFERENCES Service(Name),
  KeyName VARCHAR(100) NOT NULL,
  KeyValue VARCHAR(100),
  PRIMARY KEY (Service_Name, KeyName));

CREATE TABLE VOService (
  VO_Name VARCHAR(50) NOT NULL REFERENCES VO(VO_Name),
  Service_Name VARCHAR(50) NOT NULL REFERENCES Service(Name),
  PRIMARY KEY (VO_Name, Service_Name));

CREATE TABLE VO (
  Name VARCHAR(50) PRIMARY KEY,
  AdminContact VARCHAR(255),
  VOMSHostPort VARCHAR(255),
  VOMSAdminEndpoint VARCHAR(255));

CREATE TABLE ServiceAssociation (
  Service_Name VARCHAR(50) NOT NULL REFERENCES Service(Name),
  Service_Name_Assoc VARCHAR(50) NOT NULL REFERENCES Service(Name),
  PRIMARY KEY (Service_Name, Service_Name_Assoc));